<?php

// For working we need to create some records in the tables of Moodle.
// This records allow use needed functions in the services

// INSERT INTO `mdl_mnet_remote_rpc` (`id`, `functionname`, `xmlrpcpath`, `plugintype`, `pluginname`, `enabled`) VALUES (NULL, 'get_file', 'repository/mahara/repository.class.php/get_file', 'portfolio', 'mahara', '1');
// get NEW_ID 

// After this see in the table 'mdl_mnet_service' and get id of 'pf' record - portfolio service
// PORTFILIO_ID

// INSERT INTO `moodle`.`mdl_mnet_remote_service2rpc` (`id`, `serviceid`, `rpcid`) VALUES (NULL, 'PORTFILIO_ID', 'NEW_ID ');

// Also we need some patch MAHARA
// There is checking requesting function. And function can not have '.' in the name (except .php). But our function have '.class.php'
// So change file.
// file api\xmlrpc\dispatcher.php
// line 136 change to
//        if (0 == preg_match("@^[A-Za-z0-9]+/[A-Za-z0-9/_-]+(\.php/)?[A-Za-z0-9_-]+$@",$this->method)) { 


require_once(dirname(dirname(dirname(__FILE__))) . '/config.php');
require_once($CFG->dirroot . '/webservice/lib.php');

// authenticate the user
$token = required_param('token', PARAM_ALPHANUM);
$itemid = required_param('itemid', PARAM_ALPHANUM);
$download = optional_param('download', 0, PARAM_ALPHANUM);
$webservicelib = new webservice();
$authenticationinfo = $webservicelib->authenticate_user($token);

// GET TOKEN FROM MAHARA

require_once($CFG->dirroot . '/mnet/xmlrpc/client.php');

$client = new mnet_xmlrpc_client();
$client->set_method('portfolio/mahara/lib.php/send_content_intent');

// get user from token
$client->add_param($USER->username);        
// Get Mahara portfolio plugin config
// Or from url: portinstanceid; or form table 'portfolio_instance' by plugin name 'mahara'
$portfolioinstanceid = optional_param('pfinstid', 0, PARAM_INT); // The instance of configured portfolio plugin.
if ($portfolioinstanceid > 0) {
	; // 
} else {
	$temp_arr = $DB->get_record('portfolio_instance', array ('plugin' => 'mahara', 'visible' => 1), '*', IGNORE_MULTIPLE); // ONLY ONE RECORD !!!!
	$portfolioinstanceid = $temp_arr->id;
};

// Create array of plugin params
if (isset($portfolioinstanceid)) {
	$portfolioinstanceconf = array();
	$temp_arr = $DB->get_record('portfolio_instance_config', array('instance' => $portfolioinstanceid, 'name' => 'mnethostid')); 
	$portfolioinstanceconf['mnet_host'] = $temp_arr->value;
};
// mnet_host for portfolio plugin
$hostrecord = $DB->get_record('mnet_host', array('id' => $portfolioinstanceconf['mnet_host']));  // Mahara MNET HOST         
// mnethost object for connect
$mnethost = new mnet_peer();
$mnethost->set_wwwroot($hostrecord->wwwroot);        

// Get token from host
if (!$client->send($mnethost)) {
	foreach ($client->error as $errormessage) {
		list($code, $message) = array_map('trim',explode(':', $errormessage, 2));
		$message .= "ERROR $code:<br/>$errormessage<br/>";
	}
	$message .= print_r($message, true); 
}                

// we should get back... the send type and a shared token        
$response = (object)$client->response;

if (empty($response->sendtype) || empty($response->token)) {
	echo 'Error get Mahara token!';
}        

// token received
$portfoliotoken = $response->token; 

// ----------------------------------------------------------------------
// THE GENERAL PART
// GETTTING A FILE
// ----------------------------------------------------------------------

// IF TOKEN exists we can connect to Mahara
if ($portfoliotoken) {
	$client = new mnet_xmlrpc_client();	
	//$client->set_method('repository/mahara/repository.class.php/get_file');
	$client->set_method('repository/mahara/repository.class.php/get_file');

	// Get user_owner by itemid
	$item = $DB->get_record('block_exaportitem', array ('id' => $itemid));

	if (!$item) {
		echo 'incorrect item';
		exit;
	};
	
	// Get username by id
	$userowner = $DB->get_record('user', array ('id' => $item->userid));

	if ($item->url <> '' && stristr($item->url, $hostrecord->wwwroot)) {
		$parts = parse_url($item->url);
		parse_str($parts['query'], $query);
		$fileid = $query['file'];
	};
	
	if (!isset($fileid)) {
		echo 'incorrect url';
		exit;
	};
	
	$client->add_param($userowner->username); 
	$client->add_param($fileid);   

	
	if (!$client->send($mnethost)) {
		foreach ($client->error as $errormessage) {
			list($code, $message) = array_map('trim',explode(':', $errormessage, 2));
			$message .= "<br>  ERROR $code:<br/>$errormessage<br/> ";
		}
		echo 'Something is wrong: '.$message;
	}   

	$response = $client->response;
	$filecontent = $response[0];
	$filecontent = base64_decode($filecontent);
	// Mahara does not return filename. So we write file to temporary folder and then we can detect cont-type of this file.
	//$temp_filename = sys_get_temp_dir().'/maharatempfile';
	$temp_filename = 'maharatempfile';
	file_put_contents($temp_filename, $filecontent);
	// Get content-type from file
	$finfo = finfo_open(FILEINFO_MIME_TYPE);
	$content_type = finfo_file($finfo, $temp_filename);
	switch ($content_type) {
		case 'image/gif':
		case 'image/jpeg':
		case 'image/png':
		case 'image/tiff':
			header("Content-type: ".$content_type);
			echo $filecontent;
		default : 
			if ($download == 0) { // Icon of file.
				header("Content-type: image/png");
				$filecontent = file_get_contents('pix/file_tile.png');								
			} else { // Download file.
				header("Content-type: ".$content_type);
			};
			echo $filecontent;
//			echo 'Not image: '.$content_type;
	};
	unlink($temp_filename);
} else {
	echo 'Token does not exists';
}

/**/